;TIP1051D.LSP:  GETLTY.LSP      Get Linetype     (C)1994, Michel Chayer

;;--------ROUTINE----------
(defun getltc (/ XX LTY)
   (setq LLIST '())
   (setq XX T)
   (while (setq LTY (tblnext "LTYPE" XX))
      (setq LLIST (append LLIST (list (cdr(assoc 2 LTY)))))
      (setq XX nil)
   );while
   (setq LLIST (append LLIST (list "BYBLOCK" "BYLAYER")))
   (if (<= (length LLIST) (getvar "maxsort"))
      (setq LLIST (acad_strlsort LLIST))     
   );if
);defun GETLTC
;;--------ROUTINE----------
(defun ltyli (VALN)
   (set_tile "error" "")
   (setq LNOM (nth (atoi VALN) LLIST))
   (set_tile "EDITLT" LNOM)
);defun
;;--------ROUTINE----------
(defun ltedit (VAL)
   (set_tile "error" "")
   (setq VAL (strcase VAL))
   (if (member VAL LLIST)
      (setq LNOM VAL)
      (progn
         (set_tile "error" "Linetype not available.")
         (mode_tile "EDITLT" 2)
      );progn
   );if
);defun
;;------------------------------------------------ROUTINE----------
(defun siok ()
   (if (= (get_tile "error") "")
      (done_dialog 1)
   );if
);defun
;;-----------------------------------------MAIN PROGRAM------
(defun getlty (/ LLIST XX LTY VALN VAL DCLID)
   (getltc)
   (setq DCLID (load_dialog "GETLTY.DCL"))
   (if (not (new_dialog "GETLTY" DCLID))
      (progn
         (alert "File GETLTY.DCL not found.")
         (EXIT)
      );progn
   );if
   (set_tile "LTYCOU" (getvar "celtype"))
   (setq LNOM (getvar "celtype"))              
   (start_list "LISTLT")
   (mapcar 'add_list LLIST)                   
   (end_list)
   (set_tile "EDITLT" (getvar "celtype"))
   (action_tile "LISTLT" "(LTYLI $value)")
   (action_tile "EDITLT" "(LTEDIT $value)")
   (action_tile "accept" "(SIOK)")
   (action_tile "cancel" "(setq LNOM nil)(done_dialog 0)")
   (if (= (start_dialog) 1)                   
      (set_tile "EDITLT" LNOM)
   );if
   LNOM
);end getlty.lsp
